﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;



namespace LogicONAppDemo
{
    public partial class Form1 : Form
    {
        Socket TxSocket, RxSocket;

        int CSharpRcvPort = 14111;

        IPAddress plcIP = IPAddress.Parse("192.168.0.102");  //LogicON Soft PLC IP address
        int plcPort = 14222;  //LogicON Soft PLC Receive Port address set in CMF[0] (Comms File)

        byte[] RcvBfr = new byte[1400];
        int outputLED;

        public Form1()
        {
            InitializeComponent();

            TxSocket = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);
            RxSocket = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);

            //Setup the Receive Socket
            IPEndPoint plcEndPoint;
            plcEndPoint = new IPEndPoint(plcIP, CSharpRcvPort);
            RxSocket.Bind(plcEndPoint as EndPoint);

            timer1.Start();
        }
        
        int LdrTimer = 0;

        private void timer1_Tick(object sender, EventArgs e)
        {
            outputLED++;
            outputLED %= 5;

            if (outputLED == 0)
                outputLED = 1;

            //Receive data from LogicON SoftPLC
            while (RxSocket.Available > 0)
            {
                RxSocket.Receive(RcvBfr);  //Receive the millisecond ladder logic timer value

                label1.Text = Encoding.ASCII.GetString(RcvBfr);
                LdrTimer = Convert.ToInt32(label1.Text.Trim());
                Array.Clear(RcvBfr, 0, RcvBfr.Length); //clear the buffer for next message (avoid corrupting next message)
            }

            int data1, data2;

            if ((LdrTimer & 0x1000) == 0)
            {
                data1 = (1 << (9 - outputLED));
                data2 = (1 << outputLED);
            }
            else
            {
                data1 = LdrTimer>>4;
                data2 = ~LdrTimer>>4;
            }

            string str = string.Format("{0,8}{1,8}", data1, data2); //create transmit data string
            label3.Text = str;

            //Send udp message to LogicON SoftPLC
            IPEndPoint plcEndPoint = new IPEndPoint(plcIP, plcPort); //create the LogicON SoftPLC receive EndPoint
            TxSocket.SendTo(Encoding.ASCII.GetBytes(str), plcEndPoint as EndPoint);

        }
    }
}
